Source: https://docs.cumuluslabs.io/reference/runs.events
Content version: 4a24c0d4

# runs.events

Read the run's semantic events (JSON page or text/event-stream)

## Request {#request}

`GET /api/v1/runs/{run_id}/events`

- MCP: `runs_events`
- SDK: `client.runs.events` (SDK path arguments use `path`; MCP uses `params`).
- Minimum API key role: **viewer**.
- Idempotency: **none**.

Use the request schema below. Read IDs from earlier operation results.

## Input schema {#input-schema}

```json
{
  "parameters": [
    {
      "name": "run_id",
      "in": "path",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid"
      }
    },
    {
      "name": "after_sequence",
      "in": "query",
      "required": false,
      "schema": {
        "type": "integer",
        "minimum": 0
      }
    },
    {
      "name": "limit",
      "in": "query",
      "required": false,
      "schema": {
        "type": "integer",
        "minimum": 1,
        "maximum": 500,
        "default": 100
      }
    },
    {
      "name": "progress",
      "in": "query",
      "required": false,
      "schema": {
        "type": "string",
        "enum": [
          "live"
        ]
      }
    }
  ],
  "requestBody": null
}
```

## Responses {#responses}

```json
{
  "200": {
    "description": "Read the run's semantic events (JSON page or text/event-stream)",
    "content": {
      "application/json": {
        "schema": {
          "$ref": "#/components/schemas/RunsEventsResponse200"
        }
      },
      "text/event-stream": {
        "schema": {
          "type": "string",
          "description": "SSE: id = sequence, event = type, data = SemanticEvent; with progress=live also event = transcript.progress | effect.progress (no id), data = RunProgress"
        }
      }
    }
  },
  "4XX": {
    "description": "Typed error (ApiError)",
    "content": {
      "application/json": {
        "schema": {
          "$ref": "#/components/schemas/ApiError"
        }
      }
    }
  },
  "5XX": {
    "description": "Typed error (ApiError)",
    "content": {
      "application/json": {
        "schema": {
          "$ref": "#/components/schemas/ApiError"
        }
      }
    }
  }
}
```

## Referenced schemas {#schemas}

```json
{
  "components": {
    "schemas": {
      "RunsEventsResponse200": {
        "type": "object",
        "properties": {
          "items": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SemanticEvent"
            }
          },
          "next_after_sequence": {
            "type": "integer",
            "minimum": 0,
            "nullable": true
          }
        },
        "required": [
          "items",
          "next_after_sequence"
        ],
        "additionalProperties": false
      },
      "SemanticEvent": {
        "anyOf": [
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.admitted"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "channel": {
                    "type": "string",
                    "enum": [
                      "cloud",
                      "phone",
                      "web"
                    ]
                  },
                  "mode": {
                    "type": "string",
                    "enum": [
                      "task",
                      "chat",
                      "background",
                      "outbound",
                      "inbound"
                    ]
                  },
                  "trigger": {
                    "anyOf": [
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "sip"
                            ]
                          },
                          "number_id": {
                            "type": "string",
                            "format": "uuid"
                          },
                          "call_id_sha256": {
                            "type": "string",
                            "pattern": "^[a-f0-9]{64}$"
                          }
                        },
                        "required": [
                          "kind",
                          "number_id",
                          "call_id_sha256"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "api"
                            ]
                          },
                          "idempotency_key_sha256": {
                            "type": "string",
                            "pattern": "^[a-f0-9]{64}$"
                          }
                        },
                        "required": [
                          "kind",
                          "idempotency_key_sha256"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "schedule"
                            ]
                          },
                          "trigger_id": {
                            "type": "string",
                            "minLength": 1,
                            "maxLength": 128
                          },
                          "scheduled_for": {
                            "type": "string",
                            "format": "date-time"
                          }
                        },
                        "required": [
                          "kind",
                          "trigger_id",
                          "scheduled_for"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "event"
                            ]
                          },
                          "trigger_id": {
                            "type": "string",
                            "minLength": 1,
                            "maxLength": 128
                          },
                          "source_event_id": {
                            "type": "string",
                            "format": "uuid"
                          }
                        },
                        "required": [
                          "kind",
                          "trigger_id",
                          "source_event_id"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "callback"
                            ]
                          },
                          "source_run_id": {
                            "type": "string",
                            "format": "uuid"
                          },
                          "effect_id": {
                            "type": "string",
                            "format": "uuid"
                          }
                        },
                        "required": [
                          "kind",
                          "source_run_id",
                          "effect_id"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "evaluation"
                            ]
                          },
                          "comparison_id": {
                            "type": "string",
                            "format": "uuid"
                          }
                        },
                        "required": [
                          "kind",
                          "comparison_id"
                        ],
                        "additionalProperties": false
                      },
                      {
                        "type": "object",
                        "properties": {
                          "kind": {
                            "type": "string",
                            "enum": [
                              "test"
                            ]
                          },
                          "test_run_id": {
                            "type": "string",
                            "format": "uuid"
                          },
                          "suite_id": {
                            "type": "string",
                            "format": "uuid"
                          },
                          "case_id": {
                            "type": "string",
                            "minLength": 1,
                            "maxLength": 64,
                            "pattern": "^[a-z0-9][a-z0-9_-]*$"
                          },
                          "trial": {
                            "type": "integer",
                            "exclusiveMinimum": true,
                            "minimum": 0
                          }
                        },
                        "required": [
                          "kind",
                          "test_run_id",
                          "suite_id",
                          "case_id",
                          "trial"
                        ],
                        "additionalProperties": false
                      }
                    ]
                  },
                  "principal": {
                    "$ref": "#/components/schemas/PrincipalRef"
                  },
                  "input_sha256": {
                    "allOf": [
                      {
                        "type": "string",
                        "pattern": "^[a-f0-9]{64}$"
                      }
                    ],
                    "nullable": true
                  }
                },
                "required": [
                  "channel",
                  "mode",
                  "trigger",
                  "principal",
                  "input_sha256"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.state_changed"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "from": {
                    "type": "string",
                    "enum": [
                      "admitted",
                      "running",
                      "ending",
                      "completed",
                      "failed",
                      "cancelled",
                      "rejected",
                      "expired"
                    ]
                  },
                  "to": {
                    "type": "string",
                    "enum": [
                      "admitted",
                      "running",
                      "ending",
                      "completed",
                      "failed",
                      "cancelled",
                      "rejected",
                      "expired"
                    ]
                  },
                  "phone_from": {
                    "type": "string",
                    "enum": [
                      "admitted",
                      "preparing",
                      "awaiting_sip",
                      "dialing",
                      "ringing",
                      "active",
                      "terminating",
                      "ended",
                      "rejected",
                      "expired",
                      "setup_failed"
                    ],
                    "nullable": true
                  },
                  "phone_to": {
                    "type": "string",
                    "enum": [
                      "admitted",
                      "preparing",
                      "awaiting_sip",
                      "dialing",
                      "ringing",
                      "active",
                      "terminating",
                      "ended",
                      "rejected",
                      "expired",
                      "setup_failed"
                    ],
                    "nullable": true
                  },
                  "reason": {
                    "type": "string",
                    "pattern": "^[a-z][a-z0-9_.:-]{0,127}$"
                  }
                },
                "required": [
                  "from",
                  "to",
                  "phone_from",
                  "phone_to",
                  "reason"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.attempt_started"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_number": {
                    "type": "integer",
                    "exclusiveMinimum": true,
                    "minimum": 0
                  },
                  "worker_kind": {
                    "type": "string",
                    "enum": [
                      "voice",
                      "jobs"
                    ]
                  },
                  "worker_version": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  }
                },
                "required": [
                  "attempt_id",
                  "attempt_number",
                  "worker_kind",
                  "worker_version"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.attempt_ended"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "state": {
                    "type": "string",
                    "enum": [
                      "succeeded",
                      "failed",
                      "abandoned"
                    ]
                  },
                  "reason": {
                    "allOf": [
                      {
                        "type": "string",
                        "pattern": "^[a-z][a-z0-9_.:-]{0,127}$"
                      }
                    ],
                    "nullable": true
                  }
                },
                "required": [
                  "attempt_id",
                  "state",
                  "reason"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.node_entered"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "node_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "component_id": {
                    "allOf": [
                      {
                        "type": "string",
                        "minLength": 1,
                        "maxLength": 128
                      }
                    ],
                    "nullable": true
                  },
                  "from_node_id": {
                    "allOf": [
                      {
                        "type": "string",
                        "minLength": 1,
                        "maxLength": 128
                      }
                    ],
                    "nullable": true
                  },
                  "via": {
                    "type": "string",
                    "enum": [
                      "prompt_edge",
                      "automatic",
                      "action_result",
                      "start",
                      "global",
                      "flex_task"
                    ]
                  }
                },
                "required": [
                  "node_id",
                  "component_id",
                  "from_node_id",
                  "via"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.message"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "index": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "role": {
                    "type": "string",
                    "enum": [
                      "user",
                      "agent"
                    ]
                  },
                  "tokens": {
                    "allOf": [
                      {
                        "type": "integer",
                        "minimum": 0
                      }
                    ],
                    "nullable": true
                  }
                },
                "required": [
                  "index",
                  "role",
                  "tokens"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "transcript.updated"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "segments": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "complete": {
                    "type": "boolean"
                  }
                },
                "required": [
                  "segments",
                  "complete"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "run.ended"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "outcome": {
                    "$ref": "#/components/schemas/RunOutcome"
                  },
                  "disposition": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128,
                    "nullable": true
                  },
                  "duration_ms": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "connected_ms": {
                    "allOf": [
                      {
                        "type": "integer",
                        "minimum": 0
                      }
                    ],
                    "nullable": true
                  }
                },
                "required": [
                  "outcome",
                  "disposition",
                  "duration_ms",
                  "connected_ms"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "phone.sip_received"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "trunk_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  }
                },
                "required": [
                  "trunk_id"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "phone.amd_verdict"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "verdict": {
                    "type": "string",
                    "enum": [
                      "human",
                      "voicemail",
                      "ivr",
                      "unknown"
                    ]
                  },
                  "detection_ms": {
                    "type": "integer",
                    "minimum": 0
                  }
                },
                "required": [
                  "verdict",
                  "detection_ms"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "phone.voicemail"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "outcome": {
                    "type": "string",
                    "enum": [
                      "hung_up",
                      "left",
                      "interrupted"
                    ]
                  }
                },
                "required": [
                  "outcome"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "phone.transfer"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "effect_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "node_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "ordinal": {
                    "type": "integer",
                    "exclusiveMinimum": true,
                    "minimum": 0
                  },
                  "phase": {
                    "type": "string",
                    "enum": [
                      "refer_sent",
                      "refer_accepted",
                      "confirmed",
                      "failed",
                      "uncertain"
                    ]
                  },
                  "sip_status": {
                    "type": "integer",
                    "nullable": true
                  }
                },
                "required": [
                  "effect_id",
                  "node_id",
                  "ordinal",
                  "phase",
                  "sip_status"
                ],
                "additionalProperties": false
              },
              "sequence": {
                "type": "integer",
                "exclusiveMinimum": true,
                "minimum": 0
              },
              "recorded_at": {
                "type": "string",
                "format": "date-time"
              }
            },
            "required": [
              "owner_id",
              "environment",
              "tenant_id",
              "event_id",
              "schema_version",
              "subject",
              "correlation_id",
              "causation_id",
              "producer",
              "producer_version",
              "occurred_at",
              "privacy_class",
              "idempotency_key",
              "content",
              "run",
              "policy",
              "type",
              "data",
              "sequence",
              "recorded_at"
            ],
            "additionalProperties": false
          },
          {
            "type": "object",
            "properties": {
              "owner_id": {
                "type": "string",
                "minLength": 1
              },
              "environment": {
                "type": "string",
                "minLength": 1
              },
              "tenant_id": {
                "type": "string",
                "format": "uuid"
              },
              "event_id": {
                "type": "string",
                "format": "uuid"
              },
              "schema_version": {
                "type": "number",
                "enum": [
                  1
                ]
              },
              "subject": {
                "type": "object",
                "properties": {
                  "kind": {
                    "type": "string",
                    "enum": [
                      "run",
                      "gateway_request",
                      "publication",
                      "evaluation",
                      "comparison",
                      "operation",
                      "artifact",
                      "gpu_deployment",
                      "tenant",
                      "test_run"
                    ]
                  },
                  "id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 256
                  }
                },
                "required": [
                  "kind",
                  "id"
                ],
                "additionalProperties": false
              },
              "correlation_id": {
                "type": "string",
                "minLength": 1,
                "maxLength": 256
              },
              "causation_id": {
                "allOf": [
                  {
                    "type": "string",
                    "format": "uuid"
                  }
                ],
                "nullable": true
              },
              "producer": {
                "type": "string",
                "enum": [
                  "talos",
                  "gateway",
                  "control-plane"
                ]
              },
              "producer_version": {
                "type": "string",
                "minLength": 1,
                "maxLength": 128
              },
              "occurred_at": {
                "type": "string",
                "format": "date-time"
              },
              "privacy_class": {
                "type": "string",
                "enum": [
                  "operational",
                  "confidential"
                ]
              },
              "idempotency_key": {
                "type": "string",
                "minLength": 1,
                "maxLength": 512
              },
              "content": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/ContentRef"
                  }
                ],
                "nullable": true
              },
              "run": {
                "type": "object",
                "properties": {
                  "run_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "attempt_id": {
                    "type": "string",
                    "format": "uuid",
                    "nullable": true
                  },
                  "publication": {
                    "$ref": "#/components/schemas/PublicationRef"
                  }
                },
                "required": [
                  "run_id",
                  "attempt_id",
                  "publication"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "policy": {
                "type": "object",
                "properties": {
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "decision": {
                    "type": "string",
                    "enum": [
                      "allow",
                      "deny",
                      "unavailable"
                    ]
                  },
                  "reason": {
                    "type": "string",
                    "maxLength": 128,
                    "nullable": true
                  },
                  "policy_version": {
                    "type": "string",
                    "pattern": "^[a-f0-9]{12}$"
                  }
                },
                "required": [
                  "action_id",
                  "decision",
                  "reason",
                  "policy_version"
                ],
                "additionalProperties": false,
                "nullable": true
              },
              "type": {
                "type": "string",
                "enum": [
                  "action.requested"
                ]
              },
              "data": {
                "type": "object",
                "properties": {
                  "effect_id": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "action_id": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 128
                  },
                  "action_version": {
                    "type": "integer",
                    "exclusiveMinimum": true,
                    "minimum": 0
                  },
                  "effect_kind": {
                    "type": "string",
                    "enum": [
                      "none",
                      "transaction",
                      "gateway_inference",
                      "http",
                      "livekit",
[...]
